/* latex.c
   Time-stamp: "97/01/03 18:00:48 mik"

   Copyright (C) 1996, 1997
	Christian Schenk  <cschenk@berlin.snafu.de>

   This file is part of MiKTeX.

   MiKTeX is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
   
   MiKTeX is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with MiKTeX; if not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#include <stdio.h>
#include <process.h>
#include <miktex.h>

int
main (int argc,
      char **argv)

{
  char *cp;
  char buf[MAX_PATH];
  c4pargv[0] = argv[0];
  cp = get_cfg_value ("MiKTeX", "Root Directory", buf, sizeof (buf), 0);
  if (cp == 0)
    {
      fprintf (stderr, "MiKTeX has not been configured yet!\n");
      return (1);
    }
  else
    {
      char cmdline[300];
      int rc;
      char **newargv = _alloca (sizeof (char *) * (argc + 2));
      size_t i;
      strcpy (cmdline, cp);
      strcat (cmdline, "\\miktex\\bin\\virtex.exe");
      newargv[0] = argv[0];
      newargv[1] = "&latex";
      for (i = 1; i <= argc; i++)
	newargv[i+1] = argv[i];
      rc = _spawnv (_P_WAIT, cmdline, newargv);
      if (rc < 0)
	{
	  perror (cmdline);
	  return (1);
	}
      return (rc);
    }
}
